package com.njzscloud.common.sn;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.IService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.njzscloud.common.mp.support.PageParam;
import com.njzscloud.common.mp.support.PageResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 递增编码表
 */
@Slf4j
public class IncSnService extends ServiceImpl<IncSnMapper, IncSnEntity> implements IService<IncSnEntity> {

    /**
     * 新增
     *
     * @param incSnEntity 数据
     */
    public void add(IncSnEntity incSnEntity) {
        this.save(incSnEntity);
    }

    /**
     * 修改
     *
     * @param incSnEntity 数据
     */
    public void modify(IncSnEntity incSnEntity) {
        this.updateById(incSnEntity);
    }

    /**
     * 删除
     *
     * @param ids Ids
     */
    @Transactional(rollbackFor = Exception.class)
    public void del(List<Long> ids) {
        this.removeBatchByIds(ids);
    }

    /**
     * 详情
     *
     * @param id Id
     * @return SysIncCodeEntity 结果
     */
    public IncSnEntity detail(Long id) {
        return this.getById(id);
    }

    /**
     * 分页查询
     *
     * @param incSnEntity 筛选条件
     * @param pageParam   分页参数
     * @return PageResult&lt;SysIncCodeEntity&gt; 分页结果
     */
    public PageResult<IncSnEntity> paging(PageParam pageParam, IncSnEntity incSnEntity) {
        return PageResult.of(this.page(pageParam.toPage(), Wrappers.<IncSnEntity>query(incSnEntity)));
    }

    @Transactional(rollbackFor = Exception.class)
    public Long inc(String code) {
        IncSnEntity incCodeEntity = this.getOne(Wrappers.<IncSnEntity>lambdaQuery()
                .eq(IncSnEntity::getCode, code));
        Long val = incCodeEntity.getVal();
        val += incCodeEntity.getStep();
        this.updateById(incCodeEntity.setVal(val));
        return val;
    }
}
